﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Collections.ObjectModel;

namespace DisplayASimpleMapDesktop
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);
            winformsMap1.MouseUp += new MouseEventHandler(winformsMap1_MouseUp);

            //WorldMapKitWmsDesktopOverlay world = new WorldMapKitWmsDesktopOverlay();

            ShapeFileFeatureSource USStatesFeatureSource = new ShapeFileFeatureSource("../../Data/USStates.shp");
            USStatesFeatureSource.Open();
            Collection<Feature> features = USStatesFeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns);

            InMemoryFeatureLayer inMemoryFeatureLayer = new InMemoryFeatureLayer();
            inMemoryFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            inMemoryFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            foreach (var item in features)
            {
                inMemoryFeatureLayer.InternalFeatures.Add(item);
            }
            SimpleMarkerOverlay markerOverlay = new SimpleMarkerOverlay();
            markerOverlay.MapControl = winformsMap1;
            Marker marker1 = new Marker(new PointShape(-80, 45));
            marker1.Image = new Bitmap("../../Image/marker_green.gif");
            markerOverlay.Markers.Add(marker1);
            Marker marker2 = new Marker(new PointShape(-90, 40));
            marker2.Image = new Bitmap("../../Image/marker_green.gif");
            markerOverlay.Markers.Add(marker2);

            LayerOverlay overlay = new LayerOverlay();
            overlay.Layers.Add(inMemoryFeatureLayer);

            winformsMap1.CurrentExtent = USStatesFeatureSource.GetBoundingBox();

            //winformsMap1.Overlays.Add(world);
            winformsMap1.Overlays.Add(overlay);
            winformsMap1.Overlays.Add("MarkerOverlay",markerOverlay);
            winformsMap1.Refresh();
        }

        void winformsMap1_MouseUp(object sender, MouseEventArgs e)
        {
            // you can cancel the commented out codes and hava a try.
            //winformsMap1.Refresh(winformsMap1.Overlays["MarkerOverlay"]);
        }
    }
}
